//-----------------------------------------------------------------------------
#ifndef ValuesFromUserDlgH
#define ValuesFromUserDlgH ValuesFromUserDlgH
//-----------------------------------------------------------------------------
#include "wx/wx.h"
#include <vector>

class wxSpinCtrl;

//-----------------------------------------------------------------------------
struct ValueData
//-----------------------------------------------------------------------------
{
	wxString caption_;
	explicit ValueData( const wxString& caption ) : caption_(caption) {}
	virtual ~ValueData() {}
};

//-----------------------------------------------------------------------------
struct ValueRangeData : public ValueData
//-----------------------------------------------------------------------------
{
	int min_;
	int max_;
	int inc_;
	int def_;
	explicit ValueRangeData( const wxString& caption, int min, int max, int inc, int def ) : ValueData(caption), min_(min), max_(max), inc_(inc), def_(def) {}
};

//-----------------------------------------------------------------------------
struct ValueChoiceData : public ValueData
//-----------------------------------------------------------------------------
{
	wxArrayString choices_;
	explicit ValueChoiceData( const wxString& caption, const wxArrayString& choices ) : ValueData(caption), choices_(choices) {}
};

//-----------------------------------------------------------------------------
class ValuesFromUserDlg : public wxDialog
//-----------------------------------------------------------------------------
{
	wxButton*					pBtnOk_;
	wxButton*					pBtnCancel_;
	std::vector<wxControl*>		ctrls_;
	std::vector<int>			userInputData_;
	//-----------------------------------------------------------------------------
	enum TWidgetIDs
	//-----------------------------------------------------------------------------
	{
		widBtnOk = 1,
		widBtnCancel = 2,
		widFirst = 100,
	};
	void OnBtnOk( wxCommandEvent& );
	void OnBtnCancel( wxCommandEvent& );
public:
	ValuesFromUserDlg( wxWindow* pParent, const wxString& title, const std::vector<ValueData*>& inputData );
	const std::vector<wxControl*> GetUserInputControls( void ) const { return ctrls_; }
	// any class wishing to process wxWidgets events must use this macro
	DECLARE_EVENT_TABLE()
};

#endif // ValuesFromUserDlgH
